#!/usr/local/bin/perl
#
# ñꥹȤΩñǧѼ
#
# usage: make_dict.pl [options] wordlistե
#
# options:
#  [-startsil HMM̾]      ̵֤βǥ̾ (default: silB)
#  [-endsil HMM̾]        λ̵֤βǥ̾ (default: silE)
#

###################################
# defaults
$start_sil = "silB";
$end_sil = "silE";
###################################

if (! @ARGV) {
    &usage;
    exit;
}

$wordfile = "";
while (@ARGV) {
    $arg = shift;
    if ($arg eq "-startsil") {
        if (! @ARGV) {
            &usage;
            exit;
        }
        $start_sil = shift;
    } elsif ($arg eq "-endsil") {
        if (! @ARGV) {
            &usage;
            exit;
        }
        $end_sil = shift;
    } else {
	$wordfile = $arg;
    }
}
if ($wordfile eq "") {
    &usage;
    exit;
}
if (! -r $wordfile) {
    die "Error: cannot open wordfile \"$wordfile\"\n";
}

open(WORD, "$wordfile") || die "Error: cannot open wordfile \"$wordfile\"\n";
while(<WORD>){
    chomp;
    s/\#.*$//;
    next if (/^$/);
    ($name, $hira) = /^\s*([^\s]+)\s+([^\s].*)$/;
    $phone = &hira2phones($hira);
    print "0\t[$name]\t$phone\n";
}
print "1\t[<s>]\t$start_sil\n";
print "2\t[</s>]\t$end_sil\n";
close(WORD);

sub usage {
    print "usage: $0 [-startsil HMMname] [-endsil HMMname] wordlist\n";
}

sub hira2phones {
    $s = pop(@_);
# Ҥ餬ʡĹʳϤΤޤ
# 2ʸʤѴ§
    $s =~ s/Ǥ/ d i/g;
    $s =~ s/Ƥ/ t i/g;
    $s =~ s// s i/g;
    $s =~ s// z i/g;
    $s =~ s// ky a/g;
    $s =~ s// ky u/g;
    $s =~ s// ky o/g;
    $s =~ s// sh a/g;
    $s =~ s// sh u/g;
    $s =~ s// sh e/g;
    $s =~ s// sh o/g;
    $s =~ s// ch a/g;
    $s =~ s// ch u/g;
    $s =~ s// ch e/g;
    $s =~ s// ch o/g;
    $s =~ s/ˤ/ ny a/g;
    $s =~ s/ˤ/ ny u/g;
    $s =~ s/ˤ/ ny o/g;
    $s =~ s/Ҥ/ hy a/g;
    $s =~ s/Ҥ/ hy u/g;
    $s =~ s/Ҥ/ hy o/g;
    $s =~ s/ߤ/ my a/g;
    $s =~ s/ߤ/ my u/g;
    $s =~ s/ߤ/ my o/g;
    $s =~ s// ry a/g;
    $s =~ s// ry u/g;
    $s =~ s// ry o/g;
    $s =~ s// gy a/g;
    $s =~ s// gy u/g;
    $s =~ s// gy o/g;
    $s =~ s// j a/g;
    $s =~ s// j u/g;
    $s =~ s// j e/g;
    $s =~ s// j o/g;
    $s =~ s/Ӥ/ by a/g;
    $s =~ s/Ӥ/ by u/g;
    $s =~ s/Ӥ/ by o/g;
    $s =~ s/Ԥ/ py a/g;
    $s =~ s/Ԥ/ py u/g;
    $s =~ s/Ԥ/ py o/g;
    $s =~ s// w i/g;
    $s =~ s// w e/g;
    $s =~ s// w o/g;
    $s =~ s/դ/ f a/g;
    $s =~ s/դ/ f i/g;
    $s =~ s/դ/ f e/g;
    $s =~ s/դ/ f o/g;

# 1ʤѴ§
    $s =~ s// a/g;
    $s =~ s// i/g;
    $s =~ s// u/g;
    $s =~ s// e/g;
    $s =~ s// o/g;
    $s =~ s// k a/g;
    $s =~ s// k i/g;
    $s =~ s// k u/g;
    $s =~ s// k e/g;
    $s =~ s// k o/g;
    $s =~ s// s a/g;
    $s =~ s// sh i/g;
    $s =~ s// s u/g;
    $s =~ s// s e/g;
    $s =~ s// s o/g;
    $s =~ s// t a/g;
    $s =~ s// ch i/g;
    $s =~ s// ts u/g;
    $s =~ s// t e/g;
    $s =~ s// t o/g;
    $s =~ s// n a/g;
    $s =~ s// n i/g;
    $s =~ s// n u/g;
    $s =~ s// n e/g;
    $s =~ s// n o/g;
    $s =~ s// h a/g;
    $s =~ s// h i/g;
    $s =~ s// f u/g;
    $s =~ s// h e/g;
    $s =~ s// h o/g;
    $s =~ s// m a/g;
    $s =~ s// m i/g;
    $s =~ s// m u/g;
    $s =~ s// m e/g;
    $s =~ s// m o/g;
    $s =~ s// r a/g;
    $s =~ s// r i/g;
    $s =~ s// r u/g;
    $s =~ s// r e/g;
    $s =~ s// r o/g;
    $s =~ s// g a/g;
    $s =~ s// g i/g;
    $s =~ s// g u/g;
    $s =~ s// g e/g;
    $s =~ s// g o/g;
    $s =~ s// z a/g;
    $s =~ s// j i/g;
    $s =~ s// z u/g;
    $s =~ s// z e/g;
    $s =~ s// z o/g;
    $s =~ s// d a/g;
    $s =~ s// j i/g;
    $s =~ s// z u/g;
    $s =~ s// d e/g;
    $s =~ s// d o/g;
    $s =~ s// b a/g;
    $s =~ s// b i/g;
    $s =~ s// b u/g;
    $s =~ s// b e/g;
    $s =~ s// b o/g;
    $s =~ s// p a/g;
    $s =~ s// p i/g;
    $s =~ s// p u/g;
    $s =~ s// p e/g;
    $s =~ s// p o/g;
    $s =~ s// y a/g;
    $s =~ s// y u/g;
    $s =~ s// y o/g;
    $s =~ s// w a/g;
    $s =~ s// N/g;
    $s =~ s// q/g;
    $s =~ s//:/g;

#¾̤ʥ롼
    $s =~ s// o/g;

    $s =~ s/^ ([a-z])/$1/g;
    return $s;
}
